/*
 *	The BSL Compiler Kit
 *	A Portable BSL-Compiler, C-Version
 *	Copyright (C) 1995 Nils M. Holm
 *
 *	ANSI FUNCTION PROTOTYPES
 */

#ifdef __STDC__
	#define _P(proto)	proto
#else
	#define _P(proto)	()
#endif

int rol _P( (uint v, uint c) );
int ror _P( (uint v, uint c) );
int c_primary _P( (void) );
int c_factor _P( (void) );
int c_term _P( (void) );
int c_sum _P( (void) );
int c_sh_rot _P( (void) );
int c_binand _P( (void) );
int c_binxor _P( (void) );
int cexpr _P( (void) );
void dumpnode _P( (struct node *node, int depth) );
void dumptree _P( (struct node *root, int depth) );
void dump _P( (struct node *root) );
void dumpsym _P( (void) );
void sy_init _P( (int nsym) );
struct syment *newglob _P( (void) );
struct syment *newlocl _P( (void) );
struct syment *findsym _P( (char *name, int glob) );
struct syment *addglob _P( (char *name, uint flags, uint size) );
struct syment *addlocl _P( (char *name, uint flags, uint size) );
void clrlocals _P( (int n) );
int vecsize _P( (void) );
void alloc _P( (int size, int globl) );
struct node *d_init _P( (int type, int v) );
struct node *glob_init _P( (struct syment *sym) );
struct node *locl_init _P( (int statc) );
struct node *glob_alloc _P( (int size, int vec) );
struct node *locl_alloc _P( (int size, int vec, int statc) );
struct node *declare _P( (int globl, int flags) );
int parameters _P( (void) );
void fndecl _P( (int flags) );
struct node *fwddecl _P( (void) );
void stcdecl _P( (void) );
stcsize _P( (struct syment *stc) );
void em_init _P( (char *fname) );
char *tok2str _P( (int t) );
void do_emit _P( (char *s) );
void t_emit _P( (int t) );
void n_emit _P( (int n) );
void setlabel _P( (int l) );
void emitnode _P( (struct node *node) );
void emittree _P( (struct node *root) );
void emit _P( (struct node *root) );
void recover _P( (void) );
void error _P( (int id, int class) );
void expect _P( (char *what, int class) );
struct syment *undeclared _P( (char *name) );
void unreferenced _P( (struct syment *sp, char *scope) );
void internal _P( (int id) );
struct node *mktable _P( (int *ap) );
struct node *mkstring _P( (void) );
void order _P( (struct node *exp, struct node **inip) );
struct node *fncall _P( (struct node *node) );
struct node *primary _P( (void) );
struct node *struct_xs _P( (void) );
struct node *factor _P( (void) );
struct node *term _P( (void) );
struct node *sum _P( (void) );
struct node *sh_rot _P( (void) );
struct node *comp _P( (void) );
struct node *equation _P( (void) );
struct node *binand _P( (void) );
struct node *binxor _P( (void) );
struct node *binor _P( (void) );
struct node *logand _P( (void) );
struct node *logor _P( (void) );
struct node *cond _P( (void) );
struct node *assignment _P( (void) );
struct node *expr _P( (int comma) );
void init _P( (int nnod, int nsym) );
void end _P( (void) );
main _P( (void) );
int head _P( (int li) );
int follow _P( (int si) );
void opt_jumps _P( (void) );
int inswi _P( (int lib, int dist) );
void opt_labels _P( (void) );
void opt_branches _P( (void) );
struct node *rc_opt _P( (struct node *root) );
struct node *lc_opt _P( (struct node *root) );
struct node *opt_oper _P( (struct node *root) );
struct node *opt_cexpr _P( (struct node *root) );
struct node *optimize _P( (struct node *root) );
void pa_init _P( (void) );
struct node *if_stmt _P( (void) );
struct node *halt_stmt _P( (void) );
struct node *addnode _P( (struct node *root, int type) );
struct node *mkswitch _P( (int ncase, int dflt, int *lbl, int *val) );
struct node *switch_stmt _P( (void) );
struct node *while_stmt _P( (void) );
struct node *until_stmt _P( (void) );
struct node *for_init _P( (struct syment **psym, int begin) );
struct node *for_cond _P( (struct syment *sym, int begin, int again) );
struct node *for_incr _P( (struct syment *sym, int incr, int cont) );
struct node *for_stmt _P( (int sign) );
struct node *loop_stmt _P( (int label) );
struct node *return_stmt _P( (void) );
struct node *simple _P( (void) );
struct node *compound _P( (void) );
struct node *statement _P( (void) );
void function _P( (int label, int forw) );
struct node *declarations _P( (int globl) );
void parse _P( (void) );
void sc_init _P( (char *fname) );
int readb _P( (void) );
int comment _P( (void) );
int skip _P( (void) );
int rche _P( (void) );
int keyword _P( (char *s) );
int scanval _P( (void) );
int scan _P( (void) );
int next _P( (void) );
void ut_init _P( (int nnod) );
struct node *newnode _P( (int token) );
void freenode _P( (struct node *node) );
void clearnodes _P( (void) );
void initnodes _P( (void) );
char *strsave _P( (char *s) );
int newlabel _P( (void) );
void match _P( (int tok, char *what, int class) );
void lparen _P( (void) );
void rparen _P( (void) );
void lbrace _P( (void) );
void rbrace _P( (void) );
void semi _P( (void) );
void symname _P( (void) );
void comma _P( (void) );
void colon _P( (void) );
struct node *link _P( (struct node *root, struct node *new) );
struct node *prepend _P( (struct node *node, int type) );
struct node *cut _P( (struct node *root) );
void fetch _P( (struct node **node) );
int findsx _P( (char *name) );
void emit_sym _P( (int flags) );
