/*
 *	The BSL Compiler Kit
 *	A Portable BSL-Compiler, C-Version
 *	Copyright (C) 1995 Nils M. Holm
 *
 *	TOKEN LIST
 *
 *	These are the definitions of all tokens recognized by the
 *	SCANNER.
 */

#define FREENODE	-1		/* Mark node in free list */
#define UNUSEDNODE	-2		/* Mark unused node */
#define BADLABEL	-1		/* Mark a label bad */

#define ENDFILE	-1			/* EOF */

#define COMMA	990	/* , */

#define MOV	1000	/* = */

#define AADD	1010	/* += */
#define ASUB	1020	/* -= */
#define AMUL	1030	/* *= */
#define ADIV	1040	/* /= */
#define AMOD	1050	/* %= */
#define AAND	1060	/* &= */
#define AOR	1070	/* |= */
#define AXOR	1080	/* ^= */
#define ASHL	1090	/* <<= */
#define ASHR	1100	/* >>= */
#define AROR	1110	/* {{= */
#define AROL	1120	/* }}= */

#define ARROW	1130	/* -> */
#define COLON	1140	/* : */

#define LOR	1150	/* || */
#define LAND	1160	/* && */

#define OR	1170	/* | */
#define XOR	1180	/* ^ */
#define AND	1190	/* & */

#define EQU	1200	/* == */
#define NEQ	1210	/* != */
#define LESS	1220	/* < */
#define GRTR	1230	/* > */
#define LSEQ	1240	/* <= */
#define GTEQ	1250	/* >= */

#define SHL	1260	/* << */
#define SHR	1270	/* >> */
#define ROL	1280	/* {{ */
#define ROR	1290	/* }} */

#define ADD	1300	/* + */
#define SUB	1310	/* - */

#define MUL	1320	/* * */
#define DIV	1330	/* / */
#define MOD	1340	/* % */

#define LNOT	1350	/* ! */
#define NOT	1360	/* ~ */
#define LV	1370	/* . */
#define ADDROF	1380	/* @ */

#define LPAREN	1400	/* ( */
#define RPAREN	1410	/* ) */
#define LBRACK	1420	/* [ */
#define RBRACK	1430	/* ] */

#define LBRACE	1500	/* { */
#define RBRACE	1510	/* } */
#define SEMI	1520	/* ; */
#define HASH	1530	/* # */

#define KIF	2000	/* IF */
#define KELSE	2010	/* ELSE */
#define KWHILE	2020	/* WHILE */
#define KDO	2030	/* DO */
#define KUNTIL	2040	/* UNTIL */
#define KSWITCH	2050	/* SWITCH */
#define KCASE	2060	/* CASE */
#define KDFLT	2070	/* DEFAULT */
#define KBREAK	2080	/* BREAK */
#define KLOOP	2090	/* LOOP */
#define KRETURN	2100	/* RETURN */
#define KHALT	2110	/* HALT */
#define KSTATIC	2120	/* STATIC */
#define KVAR	2130	/* VAR */
#define KVALUE	2140	/* VALUE */
#define KPUBLIC	2150	/* PUBLIC */
#define KEXTERN	2160	/* EXTERN */
#define KFOR	2170	/* FOR */
#define KUFOR	2180	/* UFOR */
#define KFORWD	2190	/* FORWARD */
#define KSTRUCT	2200	/* STRUCTURE */
#define KUNSIGN	2210	/* UNSIGNED | U */
#define KOPTS	2220	/* OPTIONS */

#define NUMBER	3000	/* [0-9]* | '.' */
#define SYMBOL	3010	/* [A-Za-z_][A-Za-z_0-9]* */
#define STRING	3020	/* ".*" */

#define COMMENT	4000	/* //.* */

#define FUCKUP	9999	/* ??? */
