;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;	The BSL Compiler Kit
;;	BSL/86 Minimum Runtime Support: startup module
;;	Copyright (C) 1995 Nils M. Holm
;;

	.MODEL TINY
	.CODE

ADJUST	equ	17h-100h	;; MAGIC VALUE, DO NOT CHANGE !!!

	ORG	100h

start:	mov	ax,0		;; DATA SEGMENT address will be inserted
	mov	ds,ax		;; at CS:0001, so DON'T CHANGE THIS !!!

	mov	ax,4a00h	;; shrink program space to 2 segments
	mov	bx,8192
	int	21h

	jmp	usrcode		;; Add your code at the label 'usrcode'

;;
;;	STRUCTURE REGISTERS {
;;		AX, BX, CX, DX, SI, DI, BP, SP, FLAGS
;;		CS, DS, ES, SS;
;;	};
;;

	EVEN

;;	__SYS is a BSL function. It is assigned the pointer at DS:0
;;	in B0TAIL.BCO.

__SYS:	push	bp			;; create stack frame
	mov	bp,sp

	mov	ax,[bp+4]		;; get interrupt ID
	mov	byte ptr cs:[patch+ADJUST],al	;; patch INT instr.

	mov	bp,[bp+6]		;; get pointer to parameter field
	shl	bp,1			;; adjust word address

	mov	ax,[bp]			;; load registers from REGISTERS
	mov	bx,[bp+2]		;; structure (see above)
	mov	cx,[bp+4]
	mov	dx,[bp+6]
	mov	si,[bp+8]
	mov	di,[bp+10]

	push	bp			;; save parameter field
patch:	int	00			;; OPERAND WILL BE PATCHED
	pop	bp

	mov	[bp],ax			;; save registers + flags
	mov	[bp+2],bx
	mov	[bp+4],cx
	mov	[bp+6],dx
	mov	[bp+8],si
	mov	[bp+10],di
	mov	[bp+12],bp
	mov	[bp+14],sp
	lahf
	mov	al,ah
	xor	ah,ah
	mov	[bp+16],ax
	mov	[bp+18],cs
	mov	[bp+20],ds
	mov	[bp+22],es
	mov	[bp+24],ss

	mov	ax,[bp+16]		;; return flags in AX

	pop	bp			;; restore stack frame
	ret


Copyright db	"< BSL86 B0, Copyright (C) 1995 Nils M. Holm >"


usrcode:

	push	ds
	pop	es

	end	start

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
