///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL Runtime Library: I/O-Streams
//	Copyright (C) 1995 Nils M. Holm
//
//	SCLOSE ( IOS )
//
//	PURPOSE:	Close an I/O-Stream
//	RECEIVES:	IOS	- Pointer to the stream to close
//	RETURNS:	0 = success, ENDSTREAM = bad stream
//
//	NOTES: 		The IOS-functions require the dynamic memory
//			manager, so MMINIT() must be called before
//			using any IOS-functions.
//

#include( blib.hdr)
#include( ../opt.hdr)
#include( ../sys/syscall.hdr)
#include( ../mem/mem.hdr)

#define( EXTERN(x),)
#include( ios.hdr)
#undefine(EXTERN)

extern	ssync;

public sclose(ios) {
	if (!ios) return ENDSTREAM;
	#sreset(ios);
	if (ssync(ios) < 0) return ENDSTREAM;
	if (sys_close(ios.ios_fd) < 0) return ENDSTREAM;
	if (mfree(ios.ios_buf) < 0) return ENDSTREAM;
	return mfree(ios);
}
