///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL Runtime Library: I/O-Streams
//	Copyright (C) 1995 Nils M. Holm
//
//	SMORE ( IOS )
//
//	PURPOSE:	Read the next block from an I/O-Stream
//	RECEIVES:	IOS	- Pointer to the stream to read
//	RETURNS:	0 == success, ENDSTREAM == EOF | lossage
//
//	NOTES:		The IOS-functions require the dynamic memory
//			manager, so MMINIT() must be called before
//			using any IOS-functions.
//
//			This is an INTERNAL function. It is called
//			by the #SREAD macro when an input buffer
//			underflow occurs.
//

#include( blib.hdr)
#include( ../opt.hdr)
#include( ../mem/mem.hdr)
#include( ../sys/syscall.hdr)

#define( EXTERN(x),)
#include( ios.hdr)
#undefine(EXTERN)

public smore(ios) {
	var	len;

	if (ios.ios_flags & S_ERROR) {
		ios.ios_ptr = ios.ios_buf;
		return ENDSTREAM;
	}

	if (ios.ios_flags & S_READ) {
		var	iob.BUFLEN;

		len = sys_read(ios.ios_fd, iob, BUFLEN);
		if (len < 1) {
			ios.ios_end = ios.ios_buf;
			.(ios.ios_buf) = ENDSTREAM;
			ios.ios_flags |= S_ERROR;
		}
		else {
			ios.ios_end = ios.ios_buf + len;
		}
		bunpack(iob, ios.ios_buf, len);
	}
	ios.ios_ptr = ios.ios_buf;
	return len<1-> ENDSTREAM, 0;
}
