///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL Runtime Library: I/O-Streams
//	Copyright (C) 1995 Nils M. Holm
//
//	SPUTL ( IOS, BUFFER )
//
//	PURPOSE:	Write a line to an IOStream
//	RECEIVES:	IOS	- Stream to write
//			BUFFER	- Line to write
//	RETURNS:	The number of characters written, and
//			ENDSTREAM in case of a write error.
//
//	NOTES:		The IOS-functions require the dynamic memory
//			manager, so MMINIT() must be called before
//			using any IOS-functions.
//

#include( blib.hdr)
#include( ../opt.hdr)

#define( EXTERN(x),)
#include( ios.hdr)
#undefine(EXTERN)

extern	ssync;

public sputl(ios, buffer) {
	var	c, org = buffer;

	if (#seof(ios)) return ENDSTREAM;

	while (c = .buffer) {
		#sputc(ios, c);
		buffer += 1;
	}
	return buffer - org;
}
