///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL Runtime Library: I/O-Streams
//	Copyright (C) 1995 Nils M. Holm
//
//	SREAD ( IOS, BUFFER, LENGTH )
//
//	PURPOSE:	Read a block from an IOStream
//	RECEIVES:	IOS	- Stream to read
//			BUFFER	- Where to place the bock
//			LENGTH	- Number of characters to read.
//	RETURNS:	The number of characters actually read. When the
//			EOF has already been reached before the call to
//			SREAD(), ENDSTREAM will be returned.
//			ENDSTREAM will also be returned in case of
//			an error.
//
//	NOTES:		The IOS-functions require the dynamic memory
//			manager, so MMINIT() must be called before
//			using any IOS-functions.
//

#include( blib.hdr)
#include( ../opt.hdr)

#define( EXTERN(x),)
#include( ios.hdr)
#undefine(EXTERN)

extern	smore;

public sread(ios, buffer, length) {
	var	c, n = 0;

	if (#seof(ios)) return ENDSTREAM;

	length += 1;
	while (length -= 1 && !#seof(ios)) {
		c = #sgetc(ios);
		.buffer = c; buffer += 1;
		n += 1;
	}

	return n;
}
