///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL Runtime Library: I/O-Streams
//	Copyright (C) 1995 Nils M. Holm
//
//	SSEEK ( IOS, POS, HOW )
//
//	PURPOSE:	Move stream pointer
//	RECEIVES:	IOS	- Stream to seek
//			POS	- New position
//			HOW	- Seek method - see IOS.HDR
//	RETURNS:	0 = success, ENDSTREAM = lossage
//
//	NOTES:		The IOS-functions require the dynamic memory
//			manager, so MMINIT() must be called before
//			using any IOS-functions.
//

#include( blib.hdr)
#include( ../opt.hdr)
#include( ../sys/syscall.hdr)

#define( EXTERN(x),)
#include( ios.hdr)
#undefine(EXTERN)

extern	ssync;

public sseek(ios, pos, how) {
	if (how == SEEK_REL) pos -= (ios.ios_end - ios.ios_ptr);
	ssync(ios);
	return sys_seek(ios.ios_fd, pos, how)<0 -> ENDSTREAM, 0;
}
