///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL Runtime Library: I/O-Streams
//	Copyright (C) 1995 Nils M. Holm
//
//	STDOPEN ( )
//
//	PURPOSE:	Initialise the standard I/O-Streams
//	RECEIVES:	-
//	RETURNS:	0 = Success, ENSDTREAM = SCREATE() failed.
//
//	NOTES:		STDIOS() creates three IOStreams, and
//			assigns the channels SYSIN, SYSOUT, and
//			SYSERR to them. The stdio streams can be
//			accessed thru the public variables STDIN,
//			STDOUT, and STDERR, then.
//
//			The IOS-functions require the dynamic memory
//			manager, so MMINIT() must be called before
//			using any IOS-functions.
//

#include( blib.hdr)
#include( ../opt.hdr)

#define( EXTERN(x),)
#include( ios.hdr)
#undefine(EXTERN)

public var	STDIN,
		STDOUT,
		STDERR;

extern	screate, sclose;

public stdopen() {
	if (!(stdin = screate(S_READ))) return ENDSTREAM;
	stdin.ios_fd = SYSIN;

	if (!(stdout = screate(S_WRITE))) {
		sclose(stdin);
		return ENDSTREAM;
	}
	stdout.ios_fd = SYSOUT;

	if (!(stderr = screate(S_WRITE))) {
		sclose(stdin);
		sclose(stdout);
		return ENDSTREAM;
	}
	stderr.ios_fd = SYSERR;

	return 0;
}
