///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL Runtime Library: I/O-Streams
//	Copyright (C) 1995 Nils M. Holm
//
//	SWRITE ( IOS, BUFFER, LENGTH )
//
//	PURPOSE:	Write a block to an IOStream
//	RECEIVES:	IOS	- Stream to write
//			BUFFER	- Block to write
//			LENGTH	- Number of characters to write.
//	RETURNS:	The number of characters actually written.
//			ENDSTREAM will be returned in case of an
//			error.
//
//	NOTES:		The IOS-functions require the dynamic memory
//			manager, so MMINIT() must be called before
//			using any IOS-functions.
//

#include( blib.hdr)
#include( ../opt.hdr)

#define( EXTERN(x),)
#include( ios.hdr)
#undefine(EXTERN)

extern	ssync;

public swrite(ios, buffer, length) {
	var	n = 0;

	length += 1;
	while (length -= 1) {
		#sputc(ios, .buffer); buffer += 1;
		if (#seof(ios)) break;
		n += 1;
	}

	return n;
}
