///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL Runtime Library: I/O-Streams
//	Copyright (C) 1995 Nils M. Holm
//
//	SWRITEF ( IOS, FORMAT, ARGS ... )
//
//	PURPOSE:	Write formatted objects to a stream.
//	RECEIVES:	IOS	- Stream to write
//			FORMAT	- Description of objects to format
//			ARGS	- A variable number of objects to
//				format and write.
//	RETURNS:	The number of characters actually written.
//
//	NOTES:		The IOS-functions require the dynamic memory
//			manager, so MMINIT() must be called before
//			using any IOS-functions.
//

#include( blib.hdr)
#include( ../opt.hdr)

#define( EXTERN(x),)
#include( ios.hdr)
#undefine(EXTERN)

extern	vformat, sputl;

public swritef(ios, format, args) {
	var	lbuf.256;

	vformat(lbuf, format, @args);
	return sputl(ios, lbuf);
}
