///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL Runtime Library: Memory Manipulation
//	Copyright (C) 1995 Nils M. Holm
//
//	BCMP ( R1, R2, LENGTH )
//
//	PURPOSE:	Compare two memory regions
//	RECEIVES:	R1, R2	- Regions to compare
//			LENGTH	- Number of WORDS to compare.
//	RETURNS:	 > 0  -->  R1 > R2
//			 < 0  -->  R1 < R2
//			== 0  -->  R2 == R2
//			BCMP() stops after LENGTH words or at
//			the first position with different values.
//			It returns the difference of the values
//			at the last compared position (.R1 - .R2).
//

#include( blib.hdr)
#include( ../opt.hdr)

public bcmp(r1, r2, length) {
	while ((length -= 1) && !(.r1 - .r2)) {
		r1 += 1;
		r2 += 1;
	}
	return .r1 - .r2;
}
