///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL Runtime Library: Memory Manipulation
//	Copyright (C) 1995 Nils M. Holm
//
//	BRSCAN ( REGION, VAL, LENGTH )
//
//	PURPOSE:	Reverse-scan a memory region for a value.
//	RECEIVES:	REGION	- region to scan.
//			VAL	- value to find.
//			LENGTH	- Number of WORDS to scan.
//	RETURNS:	A pointer to the word found, or
//			Null if VAL is not contained in
//			REGION.
//

#include( blib.hdr)
#include( ../opt.hdr)

public brscan(region, val, length) {
	while (length) {
		length -= 1;
		if (region.length == val) break;
	}
	return (region.length == val)-> region+length, 0;
}
