///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL Runtime Library: Memory Manipulation
//	Copyright (C) 1995 Nils M. Holm
//
//	BSCAN ( REGION, VAL, LENGTH )
//
//	PURPOSE:	Scan a memory region for a value.
//	RECEIVES:	REGION	- region to scan.
//			VAL	- value to find.
//			LENGTH	- Number of WORDS to scan.
//	RETURNS:	A pointer to the word found, or
//			Null if VAL is not contained in
//			REGION.
//

#include( blib.hdr)
#include( ../opt.hdr)

public bscan(region, val, length) {
	while (length && .region - val) {
		region += 1;
		length -= 1;
	}
	return length-> region, 0;
}
