///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL Runtime Library: String Functions
//	Copyright (C) 1995 Nils M. Holm
//
//	STRCMP ( STR1, STR2 )
//
//	PURPOSE:	Compare two null-terminated strings.
//	RECEIVES:	STR1,
//			STR2	- Strings to compare.
//	RETURNS:	The difference of the first non-matching
//			characters (.STR1 - .STR2).
//			== 0	STR1 == STR2
//			< 0	STR1 < STR2
//			> 0	STR1 > STR2
//

#include( blib.hdr)
#include( ../opt.hdr)

public strcmp(str1, str2) {
	while (.str1 && .str2) {
		if (.str1 != .str2) break;
		str1 += 1;
		str2 += 1;
	}
	return .str1 - .str2;
}
