///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL/86 Runtime Library: System Call Interface
//	Copyright (C) 1995 Nils M. Holm
//
//	SYS_DUP2 ( FD, NEW )
//
//	PURPOSE:	Force duplication of an open file descriptor
//	RECEIVES:	FD	- descriptor to duplicate
//			NEW	- duplicated descriptor
//	RETURNS:	a new descriptor on success, and a
//			negative DOS error code in case of an error
//	NOTES:		When NEW is an open descriptor, SYS_DUP2()
//			will first close it, before assigning FD
//			to it.
//

#include( blib.hdr)
#include( ../opt.hdr)

public sys_dup2(fd, new) {
	var	regs.REGISTERS;

	regs.R_AX = 0x4600;
	regs.R_BX = fd;
	regs.R_CX = new;
	if (__sys(_SYSINT_, regs) & 1) return -regs.R_AX;
	return new;
}
