///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL/86 Runtime Library: System Call Interface
//	Copyright (C) 1995 Nils M. Holm
//
//	SYS_SPAWN ( NAME, ARGS )
//
//	PURPOSE:	Spawn (execute) a subprocess
//	RECEIVES:	NAME	- Path of the program to spawn
//			ARGS	- command line arguments to be
//				passed to the subprocess.
//				0 means no args.
//	RETURNS:	0 = success, -N = error (N is a DOS error code)
//

#include( blib.hdr)
#include( ../opt.hdr)

public sys_spawn(name, args) {
	var	regs.REGISTERS;
	var	pmtrs.7;
	var	prg._PATHL_/_BPW_;
	var	cmd.129/_BPW_;
	var	fcb1.34/_BPW_, fcb2.34/_BPW_;
	var	__ds;

	regs.R_AX = 0x2C00;	// Do a meaningless GETTIME call
	__sys(_SYSINT_, regs);
	__ds = regs.R_DS;	// To get the current DS setting

	if (args) {
		var	l = 0, i;

		cmd.1 = '\s';
		while (args.l) l += 1;
		i = l;
		while (i) {
			i -= 1;
			cmd.(i+2) = args.i;
		}
		cmd.(l+2) = '\r';
		cmd.(l+3) = 0;
		.cmd = l+2;
	}
	else {
		.cmd = 1;
		cmd.1 = '\r';
		cmd.2 = 0;
	}

	pack(cmd, cmd);
	pack(name, prg);

	pmtrs.0 = 0;
	pmtrs.1 = cmd * _BPW_;
	pmtrs.4 = fcb1 * _BPW_;
	pmtrs.6 = fcb2 * _BPW_;
	pmtrs.2 = pmtrs.3 = pmtrs.5 = __ds;

	regs.R_AX = 0x4B00;
	regs.R_BX = pmtrs * _BPW_;
	regs.R_DX = prg * _BPW_;
	if (__sys(_SYSINT_, regs) & 1) return -regs.R_AX;

	regs.R_AX = 0x4D00;
	__sys(_SYSINT_, regs);
	return regs.R_AX;
}
