///////////////////////////////////////////////////////////////////////////////
//
//	The BSL Compiler Kit
//	BSL/86 Runtime Library: System Call Interface
//	Copyright (C) 1995 Nils M. Holm
//
//	SYS_WRITE ( FD, BUFFER, LENGTH )
//
//	PURPOSE:	Write a block to an open FD
//	RECEIVES:	FD	- FD of file/device to write
//			BUFFER	- Write buffer
//			LENGTH	- Number of BYTES to write
//	RETURNS:	The number of BYTES actually written, or
//			-N in case of an error (N=DOS error code)
//

#include( blib.hdr)
#include( ../opt.hdr)

public sys_write(fd, buffer, length) {
	var	regs.REGISTERS;

	regs.R_AX = 0x4000;
	regs.R_BX = fd;
	regs.R_CX = length;
	regs.R_DX = buffer * _BPW_;
	if (__sys(_SYSINT_, regs) & 1) return -regs.R_AX;
	return regs.R_AX;
}
